#include <stdio.h>
#include <reg51.h>
#include <sys51.h>
#include <irq52.h>

#define mt8888  P1
#define rs0     P0_B7
#define re      P0_B6 //1=terhubung
#define hk      P0_B5 //diangkat = 1
#define ri      P0_B4
#define int0    P0_B0
#define cs      P0_B1
#define wr      P0_B2
#define rd      P0_B3
#define to      P2_B0
#define dtmf1   0x0D  //TOUT,DTMF,IRQ,BURST(50ms)
#define dtmf2   0x0F  //TOUT,CP,IRQ,BURST(100ms)
#define cp      0x0e
#define tonemd  0x1c
#define toneenb 0x05 
#define tonedis 0x04

near char LP,F01,F02, init_mode;

void initialize232(void){
    TMOD=TMOD&0x0f;
    TMOD=TMOD|0x20;//mode
    SCON=0x50;
    PCON=PCON&0x7f;
    TH1=0xfd;
    TL1=0xfd;
    EA=1;
    ET1=0;
    TR1=1;
}

void sendserial(char A){
    SBUF=A;
    while (TI==0){;}
    TI=0;
}

char receiveserial(void){
    while (RI==0){;}
    RI=0;
    return SBUF;
}

char read_stat(void){
    char out;
    rs0=1;
    cs=0;
    rd=0;
    mt8888=0xff;
    _wait_ms(1);
    out=mt8888;
    out&=0x0f;
    rd=1;
    cs=1;
    rs0=0;
    return out;
}

void write_cr(char input){
    rs0=1;
    cs=0;
    mt8888=input;
    wr=0;
    wr=1;
    cs=1;
    rs0=0;
}

void reset_8888(void){
    read_stat();
    write_cr(0x00);
    write_cr(0x00);
    write_cr(0x08);
    write_cr(0x00);
    read_stat();
}

void init_8888(char mode){
    char mode_swap;
    mode_swap=mode & 0x08;
    write_cr(mode);
    if (mode_swap==0x08){
        write_cr(mode>>=4);
    }
}

void debounce(void){
    char i;//1cycle
    for (i=0;i<18;i++){}//2cycle*18=36cycle
}//2cycle

char get_dp_number(void){
    char i=0, finish=0;
    while (hk==1){};
    debounce();
    while (hk==0){
        i++;
        finish=0;
        while (hk==0){
            finish=finish+1;
            _wait_ms(1);
            if (finish==0xff) return finish;
        };
        debounce();
        _wait_ms(60);
    }
    return i;
}    
 
void main(void){
    char mode, data;
    init_mode=dtmf1;
    re=1;
    wr=1;
    rd=1;
    rs0=1;
    cs=1;
    int0=1;
    hk=1;
    initialize232();  
    reset_8888();
    init_8888(cp);
    while(1){
        while (hk==0);
        _wait_ms(700);
        while(1){
            data=get_dp_number();
            if (data==0xff) break;
            else if (data==0x0a) sendserial('0');
            else sendserial (data+0x30);
            sendserial(' ');
        }
    }
}